# module ActiveSupport::Testing::Declarative

### Public Class Methods

describe(text) click to toggle source

    # File lib/active_support/testing/declarative.rb, line 9
                def self.describe(text)
                  class_eval "                def self.name
                      "#{text}"
                    end
    ", __FILE__, __LINE__ + 1
                end

extended(klass) click to toggle source

    # File lib/active_support/testing/declarative.rb, line 5
          def self.extended(klass)
            klass.class_eval do

              unless method_defined?(:describe)
                def self.describe(text)
                  class_eval "                def self.name
                      "#{text}"
                    end
    ", __FILE__, __LINE__ + 1
                end
              end

            end
          end

### Public Instance Methods

test(name, &block) click to toggle source

test “verify something” do

    ...

end

    # File lib/active_support/testing/declarative.rb, line 25
    def test(name, &block)
      test_name = "test_#{name.gsub(/\s+/,'_')}".to_sym
      defined = instance_method(test_name) rescue false
      raise "#{test_name} is already defined in #{self}" if defined
      if block_given?
        define_method(test_name, &block)
      else
        define_method(test_name) do
          flunk "No implementation provided for #{name}"
        end
      end
    end